<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:aws="http://webservices.amazon.com/AWSECommerceService/2005-10-05" exclude-result-prefixes="aws">

	<xsl:output method="text"/>

<!-- +- -->
<!-- | Base Template Match, General JSON Format -->
<!-- +- -->
	<xsl:template match="/">
		<xsl:value-of select="aws:ItemSearchResponse/aws:OperationRequest/aws:Arguments/aws:Argument[@Name = 'CallBack']/@Value" /><xsl:text>( {"ItemSet":{ "category":"</xsl:text><xsl:value-of select="aws:ItemSearchResponse/aws:OperationRequest/aws:Arguments/aws:Argument[@Name = 'SearchIndex']/@Value" /><xsl:text>", "keywords":"</xsl:text><xsl:value-of select="aws:ItemSearchResponse/aws:OperationRequest/aws:Arguments/aws:Argument[@Name = 'Keywords']/@Value" /><xsl:text>", "condition":"</xsl:text><xsl:value-of select="aws:ItemSearchResponse/aws:OperationRequest/aws:Arguments/aws:Argument[@Name = 'Condition']/@Value" /><xsl:text>", "responsegroup":"</xsl:text><xsl:value-of select="aws:ItemSearchResponse/aws:OperationRequest/aws:Arguments/aws:Argument[@Name = 'ResponseGroup']/@Value" /><xsl:text>", "sort":"</xsl:text><xsl:value-of select="aws:ItemSearchResponse/aws:OperationRequest/aws:Arguments/aws:Argument[@Name = 'Sort']/@Value" /><xsl:text>", "pagenum":"</xsl:text><xsl:value-of select="aws:ItemSearchResponse/aws:OperationRequest/aws:Arguments/aws:Argument[@Name = 'ItemPage']/@Value" /><xsl:text>", "TotalResults": "</xsl:text><xsl:value-of select="aws:ItemSearchResponse/aws:Items/aws:TotalResults"/><xsl:text>", </xsl:text><xsl:apply-templates/><xsl:text> {"endBuffer":"true"} ] } } ) </xsl:text>
	</xsl:template>
    <xsl:variable name="sortby">
    	<xsl:value-of select="aws:ItemSearchResponse/aws:OperationRequest/aws:Arguments/aws:Argument[@Name = 'Sort']/@Value" />
     </xsl:variable>
	<xsl:template match="aws:RequestId"></xsl:template>
	<xsl:template match="aws:RequestProcessingTime"></xsl:template>
	<xsl:template match="aws:Items">
    	<xsl:text>"Item" : [ </xsl:text>
		<xsl:apply-templates select="aws:Item"/>
        <xsl:text>], "Offer" : [ </xsl:text>
        <xsl:choose>
				<xsl:when test="$sortby='-price'">
                    <xsl:apply-templates select="aws:Item/aws:Offers/aws:Offer">
						<xsl:sort select="aws:OfferListing/aws:Price/aws:FormattedPrice" order="descending"/>
                    </xsl:apply-templates>
                 </xsl:when>
                 <xsl:otherwise>
                    <xsl:apply-templates select="aws:Item/aws:Offers/aws:Offer">
						<xsl:sort select="aws:OfferListing/aws:Price/aws:FormattedPrice"/>
                    </xsl:apply-templates>
                 </xsl:otherwise>
         </xsl:choose>
	</xsl:template>
    
 
	
<!-- +- -->
<!-- | Fetch ASIN, URL, Title, Price -->
<!-- +- -->	
	<xsl:template match="aws:Item">
		<xsl:text> {</xsl:text>
		<xsl:text>"asin":"</xsl:text><xsl:value-of select="aws:ASIN"/><xsl:text>",</xsl:text>
		<xsl:text>"url":"</xsl:text><xsl:value-of select="aws:DetailPageURL"/><xsl:text>",</xsl:text>
		<xsl:text>"title":"</xsl:text><xsl:apply-templates select="aws:ItemAttributes/aws:Title"/><xsl:text>",</xsl:text>
        <xsl:text>"thumburl":"</xsl:text><xsl:value-of select="aws:SmallImage/aws:URL"/><xsl:text>",</xsl:text>
		<xsl:text>"thumbdims":["</xsl:text><xsl:value-of select="aws:SmallImage/aws:Height"/><xsl:text>","</xsl:text><xsl:value-of select="aws:SmallImage/aws:Width"/><xsl:text>"],</xsl:text>
		<xsl:text>"vendor":"</xsl:text><xsl:apply-templates select="aws:ItemAttributes/aws:Manufacturer"/><xsl:text>",</xsl:text>
        <xsl:text>"price":"</xsl:text><xsl:value-of select="aws:Offers/aws:Offer/aws:OfferListing/aws:Price/aws:FormattedPrice"/><xsl:text>",</xsl:text>
		<xsl:text>"totalnew":"</xsl:text><xsl:value-of select="aws:OfferSummary/aws:TotalNew"/><xsl:text>",</xsl:text>
        <xsl:text>"lowestnewprice":"</xsl:text><xsl:value-of select="aws:OfferSummary/aws:LowestNewPrice/aws:FormattedPrice"/><xsl:text>",</xsl:text>
		<xsl:text>"desc":"</xsl:text><xsl:apply-templates select="aws:EditorialReviews/aws:EditorialReview/aws:Content"/><xsl:text>",</xsl:text>
		<xsl:text>"avgrating":"</xsl:text><xsl:apply-templates select="aws:CustomerReviews/aws:AverageRating"/><xsl:text>",</xsl:text>
		<xsl:text>"totalreviews":"</xsl:text><xsl:apply-templates select="aws:CustomerReviews/aws:TotalReviews"/><xsl:text>",</xsl:text>
		<xsl:text>"totalsellers":"</xsl:text><xsl:apply-templates select="aws:Offers/aws:TotalOffers"/><xsl:text>",</xsl:text>
        <xsl:text>"totalused":"</xsl:text><xsl:value-of select="aws:OfferSummary/aws:TotalUsed"/><xsl:text>",</xsl:text>
        <xsl:text>"lowestusedprice":"</xsl:text><xsl:value-of select="aws:OfferSummary/aws:LowestUsedPrice/aws:FormattedPrice"/><xsl:text>"</xsl:text>
		<xsl:text>}, </xsl:text>
	</xsl:template>

<!-- +- -->
<!-- | Title, Vendor Template, used to strip out quotation marks (which would break the javascript) -->
<!-- +- -->	
	<xsl:template match="aws:Title">
		<xsl:call-template name="find-and-replace">
			<xsl:with-param name="str" select="."/>
			<xsl:with-param name="target">"</xsl:with-param>
			<xsl:with-param name="replacement" select="''"/>
		</xsl:call-template>
	</xsl:template>
    <xsl:template match="aws:Manufacturer">
		<xsl:call-template name="find-and-replace">
			<xsl:with-param name="str" select="."/>
			<xsl:with-param name="target">"</xsl:with-param>
			<xsl:with-param name="replacement" select="''"/>
		</xsl:call-template>
	</xsl:template>

<!-- +- -->
<!-- | Description Template, used to strip out quotation marks, newlines (which would break the javascript) -->
<!-- +- -->	
	<xsl:template match="aws:Content">
		<xsl:variable name="x">	
			<xsl:call-template name="find-and-replace">
				<xsl:with-param name="str" select="."/>
				<xsl:with-param name="target">"</xsl:with-param>
				<xsl:with-param name="replacement" select="''"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="y">
			<xsl:call-template name="find-and-replace">
				<xsl:with-param name="str" select="string($x)"/>
				<xsl:with-param name="target" select="'&#10;'"/>
				<xsl:with-param name="replacement" select="''"/>
			</xsl:call-template>		
		</xsl:variable>
		<xsl:variable name="z">
			<xsl:call-template name="find-and-replace">
				<xsl:with-param name="str" select="string($y)"/>
				<xsl:with-param name="target" select="'&#13;'"/>
				<xsl:with-param name="replacement" select="''"/>
			</xsl:call-template>		
		</xsl:variable>		
		<xsl:value-of select="$z"/>		
	</xsl:template>
    
   
    <!-- +- -->
<!-- | Fetch Merchant Name, URL, Condition, Price -->
<!-- +- -->	
	<xsl:template match="aws:Item/aws:Offers/aws:Offer">
		<xsl:text> {</xsl:text>
		<xsl:text>"sellerid":"</xsl:text><xsl:apply-templates select="aws:Seller/aws:SellerId"/><xsl:text>",</xsl:text>
        <xsl:text>"nickname":"</xsl:text><xsl:apply-templates select="aws:Seller/aws:Nickname"/><xsl:text>",</xsl:text>
        <xsl:text>"merchant":"</xsl:text><xsl:apply-templates select="aws:Merchant/aws:Name"/><xsl:text>",</xsl:text>
		<xsl:text>"merchanturl":"</xsl:text><xsl:value-of select="aws:Merchant/aws:GlancePage"/><xsl:text>",</xsl:text>
		<xsl:text>"itemcondition":"</xsl:text><xsl:value-of select="aws:OfferAttributes/aws:Condition"/><xsl:text>",</xsl:text>
        <xsl:text>"offerid":"</xsl:text><xsl:value-of select="aws:OfferListing/aws:OfferListingId"/><xsl:text>",</xsl:text>
        <xsl:text>"offerprice":"</xsl:text><xsl:value-of select="aws:OfferListing/aws:Price/aws:FormattedPrice"/><xsl:text>"}, </xsl:text>
	</xsl:template>
		
<!-- +- -->
<!-- | Merchant Template, used to strip out quotation marks (which would break the javascript) -->
<!-- +- -->	
	<xsl:template match="aws:Name">
		<xsl:call-template name="find-and-replace">
			<xsl:with-param name="str" select="."/>
			<xsl:with-param name="target">"</xsl:with-param>
			<xsl:with-param name="replacement" select="''"/>
		</xsl:call-template>
	</xsl:template>
    
<!-- +- -->
<!-- | Search-and-Replace Template, swaps one string (target) with another (replacement) -->
<!-- +- -->	
	<xsl:template name="find-and-replace">
		<xsl:param name="str"/>
		<xsl:param name="target"/>
		<xsl:param name="replacement"/>
		<xsl:choose>
			<xsl:when test="$target and contains($str, $target)">
				<xsl:value-of select="substring-before($str, $target)" disable-output-escaping="yes"/>
				<xsl:value-of select="$replacement" disable-output-escaping="yes"/>
				<xsl:call-template name="find-and-replace">
					<xsl:with-param name="str" select="substring-after($str, $target)"/>
					<xsl:with-param name="target" select="$target"/>
					<xsl:with-param name="replacement" select="$replacement"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$str" disable-output-escaping="yes"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>	
	
</xsl:stylesheet>





<!-- Stylus Studio meta-information - (c) 2004-2006. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" url="xml2.xml" htmlbaseurl="" outputurl="" processortype="internal" useresolver="yes" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/><MapperBlockPosition></MapperBlockPosition><TemplateContext></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->